	SUBROUTINE DELBND(IQPNT)
****************************************************************
*   Control module for package of programs finding change in   *
*   all potential parameters of the LMTO method as wells as    *
*   change in the numbers of states matrix. The induced charge *
*   density is also calculated.                                *
****************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
        INTEGER NITER(0:NENVMAX,-1:2),IS(NPAT),ILST(NSORTMAX)
     &    ,ILSB(NSORTMAX),ISG(NOPRMAX,NOPRMAX),KSYMPN(NOPRMAX,KMAX)
     &    ,ILSV(NSORTMAX),NBNDF(NPANMAX),NBNDE(NPANMAX),NBNDT(NPANMAX)
        COMMON /CONTROL/LIFT,LMTO,NSPH,NINT,NPF,MODE          !!! from readini
        COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM         !!! from readini
	COMMON /KAPPAR/ NPAN                                  !!! from readini
	COMMON /SUBGROUP/NSGQ,NGEQ,ISG,KSYMPN                 !!! from symmsh
        COMMON /MAGCOM/ ITERMAX,NITER                         !!! from qvector
        COMMON /PTBCOM/ NGSHL,NGPTB                           !!! from plwptb
        COMMON /NBANDS/ NBNDF,NBNDE,NBNDT                     !!! from readini
	COMMON /MESH/   NPNT                                  !!! from bzmesh
        COMMON /SPIN/   NSPIN                                 !!! from readini
	COMMON /UNIT/   IUN                                   !!! from readini
C DO GLOBALLY OVER POLARIZATIONS OF MAGNETIC FIELD
C I.   INITIALIZATION
	DO MY=-1,2                              !!! over polarizations
	DO IGPTB=0,NGPTB                        !!! over g-vectors
	IF(NITER(IGPTB,MY).NE.0.AND.MODE.NE.5)THEN
	CALL DROFILES(IGPTB,MY,IQPNT,33,'I')    !!! initialize change in density
	ENDIF
	ENDDO                                   !!! over g-vectors
	ENDDO                                   !!! over polarizations
	DO 3000 IPAN=1,NPAN                     !!! DO over energy panels
C II.  COMPUTE ORIGINAL POTENTIAL PARAMETERS
	CALL SPOTPAR(IPAN)                      !!! different pot. parameters
	CALL SLMTPAR(IPAN)                      !!! some compbinations of them
        CALL SOVRPAR(IPAN)                      !!! overlap potential par.
	CALL SNMTPAR(IPAN)                      !!! NMT-potential parameters
        CALL SHUBPAR(IPAN)                      !!! Hubbard corrections
        CALL SORBPAR(IPAN)                      !!! SO-coupling parameters
C III. COMPUTE POTENTIAL PARAMETERS VARIATIONS
	DO MY=-1,2                              !!! over polarizations
	DO IGPTB=0,NGPTB                        !!! over g-vectors
	IF(NITER(IGPTB,MY).NE.0)THEN
	CALL DSVFILES(IGPTB,MY,IQPNT,36,'R')    !!! read change in the potential
   	CALL DSSETENY(IGPTB,MY,IPAN,IQPNT)      !!! change in set of Eny
   	CALL DSPOTPAR(IGPTB,MY,IPAN,IQPNT)      !!! change in rad.fun.
   	CALL DSLMTPAR(IGPTB,MY,IPAN,IQPNT)      !!! change in  MT-pot.par.
   	CALL DSNMTPAR(IGPTB,MY,IPAN,IQPNT)      !!! change in NMT-pot.par.
    	CALL DSHUBPAR(IGPTB,MY,IPAN,IQPNT)      !!! change in HUB-pot.par.
CCC 	CALL DSORBPAR(IGPTB,MY,IPAN,IQPNT)      !!! change in ORB-pot.par.
   	CALL DSNULTOS(IGPTB,MY,IPAN,IQPNT)      !!! zeroes to the change in TOS
	ENDIF
	ENDDO                                   !!! over g-vectors
	ENDDO                                   !!! over polarizations
	DO 2000 ISGQ=1,NSGQ                     !!! DO over star of the q-vector
	DO 1000 IPNT=1,NPNT                     !!! DO over k-points
	IF(KSYMPN(ISGQ,IPNT).LT.0)GOTO1000
   	CALL SLMTVEC(IPNT,ISGQ,IPAN,IQPNT)      !!! rotate variational coef
	DO MY=-1,2                              !!! over polarizations
	DO IGPTB=0,NGPTB                        !!! over g-vectors
	IF(NITER(IGPTB,MY).NE.0)THEN
C IV.  COMPUTE FIRST-ORDER CHANGE IN THE LMTO MATRICES
C 1) PART FROM THE MT-SPHERE
   	CALL SDELMAT(IGPTB,MY,IPNT,ISGQ,IPAN,IQPNT)!!!"total"change in H,O
C V.   COMPUTE CHANGE IN NUMBER-OF-STATES MATRIX AND PSEUDODENSITY
	IF(MODE.NE.5)THEN
C 1) PART FROM THE MT-SPHERE
   	CALL DTOSPAR(IGPTB,MY,IPNT,ISGQ,IPAN,IQPNT)!!! find change in TOS
	ENDIF
	ENDIF
	ENDDO                                   !!! over g-vectors
	ENDDO                                   !!! over polarizations
1000    CONTINUE                                !!! ENDDO over k-points
2000    CONTINUE                                !!! ENDDO over star of q-vector
	DO MY=-1,2                              !!! over polarizations
	DO IGPTB=0,NGPTB                        !!! over g-vectors
	IF(NITER(IGPTB,MY).NE.0.AND.MODE.NE.5)THEN
C IX.  COMPUTE FIRST-ORDER CHANGE IN CHARGE DENSITY
   	CALL SDELRHO(IGPTB,MY,IPAN,IQPNT)       !!! induced density within MTs
        CALL DRHOHUB(IGPTB,MY,IPAN,IQPNT)       !!! induced occupancies
	ENDIF
	ENDDO                                   !!! over g-vectors
	ENDDO                                   !!! over polarizations
C REMOVE SCRATCH FILES
	CLOSE(UNIT=13,STATUS='DELETE')          !!! file with Hpar
	DO MY=-1,2                              !!! over polarizations
	DO IGPTB=0,NGPTB                        !!! over g-vectors
	IF(NITER(IGPTB,MY).NE.0)THEN
	CALL NMTFILES(IGPTB,MY,IPAN,0,IQPNT,41,'D')!!! file with change in Hpar
	CALL NMTFILES(IGPTB,MY,IPAN,0,IQPNT,43,'D')!!! file with change in Bpar
	CALL TOSFILES(IGPTB,MY,IPAN,0,IQPNT,42,'D')!!! file with change in TOS
	CALL TOSFILES(IGPTB,MY,IPAN,0,IQPNT,44,'D')!!! file with change in BOS
	ENDIF
	ENDDO                                   !!! over g-vectors
	ENDDO                                   !!! over polarizations
3000    CONTINUE                                !!! ENDDO over energy panels
C X.   SYMMETRIZATION PROGRAMS
	CALL SYMDRHO(IQPNT)                     !!! symmetrize change in density
        CALL SYMDHUB(IQPNT)                     !!! symmetrize change in TOS
	END
