	SUBROUTINE DELVCOUL(IGPTB,MY,IQPNT)
**************************************************************
*  Calculation of the Coulomb potential variation            *
*  due to presense of a perturbation with wavevector q.      *
**************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &   ,IS(NPAT),NRAD(NSORTMAX)
	COMPLEX*16 
     &    DPOT(0:NRADMAX,LMMAXV,NPAT,NSPINMAX)
     &   ,DBXC(0:NRADMAX,LMMAXV,NPAT,NSPINMAX)
     &   ,DRHO(0:NRADMAX,LMMAXV,NPAT,NSPINMAX)
     &   ,DMAG(0:NRADMAX,LMMAXV,NPAT,NSPINMAX)
     &   ,DPSMOM1(LMMAXV,NPAT,NSPINMAX,0:NENVMAX,-1:2)
     &   ,DPSMOM (LMMAXV,NPAT,NSPINMAX,0:NENVMAX,-1:2)
     &   ,DELMAD (LMMAXV,NPAT,NSPINMAX,0:NENVMAX,-1:2)
     &   ,DELMRO (LMMAXV,NPAT,NSPINMAX,0:NENVMAX,-1:2)
     &   ,DVC1(0:NRADMAX),DVC2(0:NRADMAX)
	DIMENSION H(NSORTMAX),R(0:NRADMAX,NSORTMAX)
     &   ,SMT(NSORTMAX),RL(0:NRADMAX,0:LMAXV,NSORTMAX)
     &   ,DR(0:NRADMAX,NSORTMAX),WEIGHT(0:NRADMAX,NSORTMAX)
C Controls:
	COMMON /CONTROL/LIFT,LMTO,NSPH,NINT,NPF,MODE        !!! from readini
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM       !!! from readini
	COMMON /ORBS/   NORBS                               !!! from readini
	COMMON /SPIN/   NSPIN                               !!! from readini
C Inputs:
	COMMON /POTCOM/ SWZ,SMT                             !!! from readini
C Density:
	COMMON /DELRO/  DRHO,DMAG                           !!! from delro
	COMMON /DROMULT/DELMRO,DPSMOM,DPSMOM1,DELMAD        !!! from multdro
C Potential:
	COMMON /DELPOT/ DPOT,DBXC                           !!! from dvcoul
C Radial mesh:
	COMMON /RADMESH/NRAD,H,R,DR,WEIGHT,RL               !!! from radmsh
C Outputs:
	COMMON /UNIT/   IUN                                 !!! from readini
	DATA PI/3.141592653589793D0/
	IF(NORBS.EQ.1.AND.MY.NE.0.AND.MY.NE.2)RETURN
	SQPI4=2.D0*SQRT(PI)
C   ***** CALCULATE EFFECTIVE POTENTIAL VARIATION *****
	DO ISPIN=1,NSPIN                    !!! over spins
	DO IATOM=1,NATOM                    !!! over all atoms in cell
	ISORT=IS(IATOM)
	DO L=0,ILSV(ISORT)                  !!! over l
	DO M=-L,L                           !!! over m
	LM=L*(L+1)+M+1
	SL=SMT(ISORT)**L
C   COULOMB CONTRIBUTION (CHANGE IN THE MULTIPOLE FIELD)
	DO IRAD=0,NRAD(ISORT)               !!! over radial mesh
	DPOT(IRAD,LM,IATOM,ISPIN)=DPOT(IRAD,LM,IATOM,ISPIN)+
     &  2.D0*(DELMAD(LM,IATOM,1,IGPTB,MY)+
     &  DELMAD(LM,IATOM,NSPIN,IGPTB,MY))/
     &  2.D0*DBLE(NSPIN)*RL(IRAD,L,ISORT)/SL
        ENDDO                               !!! over radial mesh
C   COULOMB CONTRIBUTION  (INTERNAL PART)
	CALL DPOISS1(DVC1,DVC2,L,M,IATOM,IGPTB,MY)! solve Poisson equation
	PL=2.D0/(2.D0*L+1.D0)
	DO IRAD=0,NRAD(ISORT)               !!! over radial mesh
	DPOT(IRAD,LM,IATOM,ISPIN)=DPOT(IRAD,LM,IATOM,ISPIN)+
     &  PL*(DVC1(IRAD)+DVC2(IRAD))
        ENDDO                               !!! over radial mesh
        ENDDO                               !!! over m
        ENDDO                               !!! over l
        ENDDO                               !!! over all atoms in cell
        ENDDO                               !!! over spins
	END




	SUBROUTINE DELVZERO(IGPTB,MY,IQPNT)
************************************************************
*  Calculate change in the MT-zero of the full potential.  *
************************************************************ 
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &   ,IS(NPAT),NRAD(NSORTMAX)
	COMPLEX*16 DVAV(0:NENVMAX,-1:2)
     &   ,DVMT(NPAT,0:NENVMAX,-1:2,NSPINMAX),DVMT0(0:NENVMAX,-1:2)
     &   ,DPOT(0:NRADMAX,LMMAXV,NPAT,NSPINMAX)
     &   ,DBXC(0:NRADMAX,LMMAXV,NPAT,NSPINMAX)
	DIMENSION SMT(NSORTMAX),GPLW(3,0:NPLWMAX),ORTH(2:3)
	CHARACTER TXTEL(NSORTMAX)*10
C Controls:
	COMMON /CONTROL/LIFT,LMTO,NSPH,NINT                 !!! from readini
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM       !!! from readini
	COMMON /SPIN/   NSPIN                               !!! from readini
C Inputs:
	COMMON /POTCOM/ SWZ,SMT                             !!! from readini
        COMMON /LATPAR/ PAR,ORTH,OMEGAC                     !!! from readini
C Potential:
	COMMON /DELPOT/ DPOT,DBXC                           !!! from delpot
	COMMON /ZERODV/ DVAV,DVMT,DVMT0                     !!! from dvzero
C Radial mesh:
	COMMON /RADMESH/NRAD                                !!! from radmsh
C Plane waves:
	COMMON /PLWMESH/NPLW,GPLW                           !!! from plwmsh
C Outputs:
	COMMON /UNIT/   IUN                                 !!! from readini
	COMMON /TXTEL/  TXTEL                               !!! from readini
	DATA PI/3.141592653589793D0/
	SQPI4=2.D0*SQRT(PI)
	DVMT0(IGPTB,MY)=(0.D0,0.D0)
C  DEFINE CHANGE IN THE MT-ZERO
	OMEGAM=0.D0
	DO ISPIN=1,NSPIN
	DO IATOM=1,NATOM
	ISORT=IS(IATOM)
	DVMT(IATOM,IGPTB,MY,ISPIN)=DPOT(NRAD(ISORT),1,IATOM,ISPIN)/
     &  SQPI4
        DVMT0(IGPTB,MY)=DVMT0(IGPTB,MY)+DVMT(IATOM,IGPTB,MY,ISPIN)
	OMEGAM=OMEGAM+4.D0*PI/3.D0*SMT(ISORT)**3
        ENDDO     
        ENDDO     
C       DVMT0(IGPTB,MY)=DVMT0(IGPTB,MY)/DBLE(NATOM*NSPIN)
	DVMT0(IGPTB,MY)=(0.D0,0.D0)
	OMEGAM=OMEGAM/DBLE(NSPIN)
C  SET AVERAGE CHANGE IN THE INTERSTITIAL POTENTIAL
        DVAV(IGPTB,MY)=0.D0
        DVAV(IGPTB,MY)=DVAV(IGPTB,MY)/(OMEGAC-OMEGAM)
C  SHIFT VARIATION OF THE POTENTIAL ACOORDING TO NEW ZERO
	DO ISPIN=1,NSPIN
	DO IATOM=1,NATOM
	ISORT=IS(IATOM)
	DO IRAD=0,NRAD(ISORT)
	DPOT(IRAD,1,IATOM,ISPIN)=DPOT(IRAD,1,IATOM,ISPIN)-
     &  DVMT0(IGPTB,MY)*SQPI4
        ENDDO     
        ENDDO     
        ENDDO     
	END




	SUBROUTINE DPOISS1(DVC1,DVC2,L,M,IATOM,IGPTB,MY)
*************************************************************
*         The solution of the Poisson equation              *
*************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX),IS(NPAT)
     &   ,NRAD(NSORTMAX)
	COMPLEX*16 WORK1(0:NRADMAX),WORK2(0:NRADMAX)
     &   ,DRHO(0:NRADMAX,LMMAXV,NPAT,NSPINMAX)
     &   ,DVC1(0:NRADMAX),DVC2(0:NRADMAX)
	DIMENSION H(NSORTMAX),DR(0:NRADMAX,NSORTMAX)
     &   ,RL(0:NRADMAX,0:LMAXV,NSORTMAX)
     &   ,WEIGHT(0:NRADMAX,NSORTMAX)
     &   ,R(0:NRADMAX,NSORTMAX)
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM     !!! from readini
	COMMON /RADMESH/NRAD,H,R,DR,WEIGHT,RL             !!! from radmsh
        COMMON /SPIN/   NSPIN                             !!! from readini
	COMMON /DELRO/  DRHO                              !!! from delrho
	DATA PI/3.141592653589793D0/
C   INITIATION
	ISORT=IS(IATOM)
	LM=L*(L+1)+M+1
C   SOLUTION OF THE POISSON EQUATION
	DO IRAD=0,NRAD(ISORT)
	WORK1(IRAD)=(DRHO(IRAD,LM,IATOM,1)+DRHO(IRAD,LM,IATOM,NSPIN))/
     &  2.D0*DBLE(NSPIN)*WEIGHT(IRAD,ISORT)*RL(IRAD,L,ISORT)
	ENDDO
	CALL CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	DVC1(0)=(0.D0,0.D0)
	DO IRAD=1,NRAD(ISORT)
	DVC1(IRAD)=WORK2(IRAD)
	DO L1=1,L+1
	DVC1(IRAD)=DVC1(IRAD)/R(IRAD,ISORT)
	ENDDO
	ENDDO
	WORK1(0)=(0.D0,0.D0)
	DO IRAD=1,NRAD(ISORT)
	WORK1(IRAD)=(DRHO(IRAD,LM,IATOM,1)+DRHO(IRAD,LM,IATOM,NSPIN))/
     &  2.D0*DBLE(NSPIN)*WEIGHT(IRAD,ISORT)
	DO L1=1,L+1
	WORK1(IRAD)=WORK1(IRAD)/R(IRAD,ISORT)
	ENDDO
	ENDDO
	IF(L.LE.1)THEN
	CALL CQD(H(ISORT),WORK1(0),WORK2(0),NRAD(ISORT)+1)
	ELSE
	CALL CQD(H(ISORT),WORK1(2),WORK2(2),NRAD(ISORT)-1)
	WORK2(1)=-(WORK1(1)+WORK1(2))*0.5D0*H(ISORT)
	ENDIF
	DVC2(0)=(0.D0,0.D0)
	DO IRAD=1,NRAD(ISORT)
	DVC2(IRAD)=(WORK2(NRAD(ISORT))-WORK2(IRAD))*RL(IRAD,L,ISORT)
	ENDDO
	IF(L.EQ.0)DVC2(0)=WORK2(NRAD(ISORT))
	END
