	SUBROUTINE MULTRHO
**************************************************************
*  Calculates multipoles from atomic cells.                  *
*  Written by S.Yu.Savrasov, last revision: 30.11.92         *
**************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &    ,IS(NPAT),NHSORT(NSORTMAX),LMSYM(LMMAXV,NPAT),NRAD(NSORTMAX)
	DIMENSION ZCOR(NSORTMAX),H(NSORTMAX),R(0:NRADMAX,NSORTMAX)
     &    ,RL(0:NRADMAX,0:LMAXV,NSORTMAX),SMT(NSORTMAX),Z(NSORTMAX)
     &    ,WEIGHT(0:NRADMAX,NSORTMAX),DR(0:NRADMAX,NSORTMAX)
	COMPLEX*16 QMAD(NSYMMAX,NPAT,NSPINMAX)
     &    ,ROVALDS(3,NSYMMAX,NPAT,NSPINMAX),WORK1(0:NRADMAX)
     &    ,RO(0:NRADMAX,NSYMMAX,NPAT,NSPINMAX),SS(LMMAXV1,LMMAXV1)
     &    ,TMP,WORK2(0:NRADMAX),AMTOT(NSYMMAX,NPAT,NSPINMAX)
	CHARACTER TXTEL(NSORTMAX)*10
	LOGICAL SYM(LMMAXV,NPAT)
	COMMON /CONTROL/MAN,LMTO,NLR,NINT                   !!! from init
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM,NHSORT!!! from init
	COMMON /POTCOM/ SWZ,SMT                             !!! from init
	COMMON /DENS/   RO,ROVALDS                          !!! from rofull
	COMMON /RADMESH/NRAD,H,R,DR,WEIGHT,RL               !!! from radmsh
	COMMON /MULTRO/ Z,ZCOR,AMTOT,QMAD                   !!! from strmat
	COMMON /SYMMLM/ SYM,LMSYM                           !!! from symlm
	COMMON /SPIN/   NSPIN                               !!! from init
	COMMON /UNIT/   IUN                                 !!! from init
	COMMON /TXTEL/  TXTEL                               !!! from init
	DATA PI/3.141592653589793D0/
	SQPI4=2.D0*SQRT(PI)
C   CALCULATE MOMENTS OF THE FULL DENSITY WITHIN SPHERE
	DO 60 ISPIN=1,NSPIN
	DO 50 IATOM=1,NATOM
	ISORT=IS(IATOM)
	DO 40 L=0,ILSV(ISORT)
	DO 30 M=-L,L
	LM=L*(L+1)+M+1
	IF(SYM(LM,IATOM))THEN       !!! only for non-zero components
	ISYM=LMSYM(LM,IATOM)
	DO 20 IRAD=0,NRAD(ISORT)
	WORK1(IRAD)=RO(IRAD,ISYM,IATOM,ISPIN)*
     &  RL(IRAD,L,ISORT)*WEIGHT(IRAD,ISORT)/SQRT(4.D0*PI)
  20 	CONTINUE
	CALL CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	AMTOT(ISYM,IATOM,ISPIN)=WORK2(NRAD(ISORT))/SMT(ISORT)**L
	ENDIF                      !!! only for non-zero components
  30	CONTINUE
  40	CONTINUE
	AMTOT(1,IATOM,ISPIN)=AMTOT(1,IATOM,ISPIN)-Z(ISORT)/DFLOAT(NSPIN)
  50	CONTINUE
  60	CONTINUE
C   CALCULATE MULTIPOLE FIELD
	DO 130 ISPIN=1,NSPIN                    !!! over spins
	DO 120 IATOM=1,NATOM                    !!! over iatom
	ISORT=IS(IATOM)
	DO 70 L=0,ILSV(ISORT)                 !!! over l
	ST=SQRT(4.D0*PI)/SMT(ISORT)/(2.D0*L+1.D0)
	DO 65 M=-L,L                            !!! over m
	LM=L*(L+1)+M+1
	IF(SYM(LM,IATOM))THEN
	ISYM=LMSYM(LM,IATOM)
	QMAD(ISYM,IATOM,ISPIN)=(0.D0,0.D0)
	ENDIF
  65	CONTINUE                                 !!! over m
  70	CONTINUE                                 !!! over l 
	DO 110 JATOM=1,NATOM                     !!! over jatom
	JSORT=IS(JATOM)
	CALL STRMAT(IATOM,JATOM,SS)              !!! restore str.matrix
	DO 100 L=0,ILSV(ISORT)                   !!! over l
	ST=SQRT(4.D0*PI)/SMT(ISORT)/(2.D0*L+1.D0)
	DO 90 M=-L,L                             !!! over m
	LM=L*(L+1)+M+1
	IF(SYM(LM,IATOM))THEN
	ISYM=LMSYM(LM,IATOM)
	DO 80 L1=0,ILSV(JSORT)                   !!! over l1
	ST1=1.D0/SMT(JSORT)/(2.D0*L1+1.D0)
	SL1=SMT(JSORT)**L1
	DZ=0.D0/DBLE(NSPIN)
	DO 75 M1=-L1,L1                          !!! over m1
	LM1=L1*(L1+1)+M1+1
	IF(SYM(LM1,JATOM))THEN
	JSYM=LMSYM(LM1,JATOM)
	QMAD(ISYM,IATOM,ISPIN)=QMAD(ISYM,IATOM,ISPIN)-ST*SS(LM,LM1)*
     &  (AMTOT(JSYM,JATOM,ISPIN)+DZ)*ST1
	ENDIF
  75	CONTINUE                                 !!! over m1
  80	CONTINUE                                 !!! over l1
	ENDIF
  90	CONTINUE                                 !!! over m
 100	CONTINUE                                 !!! over l
 110	CONTINUE                                 !!! over jatom
 120	CONTINUE                                 !!! over iatom
 130	CONTINUE                                 !!! over spins
	END
