	SUBROUTINE SORBPAR(IPAN)
***************************************************************
* Calculates potential parameters due to spin-orbit coupling. *
***************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &    ,LMSYM(LMMAXV,NPAT),NRAD(NSORTMAX),NKAP(NPANMAX)
     &    ,IATS(NPAT,NPANMAX),ISTS(NSORTMAX,NPANMAX),LR(NSORTMAX)
	COMPLEX*16 EK(NKAPMAX,NPANMAX),EKAP(NKAPMAX,NPANMAX)
     &    ,HPARHH(LIMLMB,LIMLMB,NPAT),HPARJH(LIMLMT,LIMLMB,NPAT)
     &    ,HPARHJ(LIMLMB,LIMLMT,NPAT),HPARJJ(LIMLMT,LIMLMT,NPAT)
     &    ,SPARHH(NKAPMAX,NKAPMAX,0:LMAXB,NSORTMAX,NSPINMAX)
     &    ,SPARJH(NKAPMAX,NKAPMAX,0:LMAXB,NSORTMAX,NSPINMAX)
     &    ,SPARHJ(NKAPMAX,NKAPMAX,0:LMAXB,NSORTMAX,NSPINMAX)
     &    ,SPARJJ(NKAPMAX,NKAPMAX,0:LMAXT,NSORTMAX,NSPINMAX)
	COMPLEX*16 V(0:NRADMAX,NSYMMAX,NPAT,NSPINMAX)
     &    ,FIH(0:NRADMAX,0:LMAXT,NKAPMAX,NSPINMAX)
     &    ,FIJ(0:NRADMAX,0:LMAXT,NKAPMAX,NSPINMAX)
     &    ,AAH(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &    ,AAJ(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &    ,BBH(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &    ,BBJ(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &    ,WORK2(0:NRADMAX),WORK1(0:NRADMAX)
	DIMENSION SMT(NSORTMAX),VSPH(0:NRADMAX,NSORTMAX,NSPINMAX)
     &    ,C(0:LMAXV+1,LMMAXV1,LMMAXV1),GAM(0:LMAXT,NSORTMAX)
     &    ,H(NSORTMAX),R(0:NRADMAX,NSORTMAX),WEIGHT(0:NRADMAX,NSORTMAX)
     &    ,AFI(0:NRADMAX,0:LMAXT),AFID(0:NRADMAX,0:LMAXT)
     &    ,AFIP(0:NRADMAX,0:LMAXT),AFIDP(0:NRADMAX,0:LMAXT)
     &    ,AFIDDS(0:LMAXT),AFIDDPS(0:LMAXT),DR(0:NRADMAX,NSORTMAX)
     &    ,ENY(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &    ,DNY(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &    ,TNY(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &    ,VBAR(0:NRADMAX),VDER(0:NRADMAX),Z(NSORTMAX)
	LOGICAL SYM(LMMAXV,NPAT),LOG1,LOG
     &    ,LTPAN(0:LMAXT+1,NPAT,NKAPMAX,NPANMAX)
     &    ,LSPAN(0:LMAXT+1,NSORTMAX,NKAPMAX,NPANMAX)
	CHARACTER*60 SCRFILE(100) 
C Controls:
	COMMON /CONTROL/MAN,LMTO,NLR,NOVR                !!! from readini
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM    !!! from readini
	COMMON /ORBS/   NORBS                            !!! from readini
	COMMON /SPIN/   NSPIN                            !!! from readini
	COMMON /RELATIV/LR                               !!! from readini
C Inputs:
	COMMON /POTCOM/ SWZ,SMT,VSPH,V                   !!! from vfull
	COMMON /MULTRO/ Z                                !!! from readini
	COMMON /KAPPAR/ NPAN,NKAP,EK,EKAP                !!! from readini
	COMMON /INPPAR/ TNY,ENY,DNY                      !!! from potpar
	COMMON /PANPAR/ LTPAN,LSPAN,IATS,ISTS            !!! from readini
	COMMON /SYMMLM/ SYM,LMSYM                        !!! from symmlm 
C Pot.pars:
	COMMON /LMTPAR/ GAM,AAH,BBH,AAJ,BBJ              !!! from potpar
	COMMON /ORBPAR/ SPARHH,SPARJH,SPARHJ,SPARJJ      !!! from orbpar
C Temporary:
	COMMON /STORE1/ HPARHH,HPARJH,HPARHJ,HPARJJ      !!! from orbpar
	COMMON /STORE2/ AFI,AFID,AFIP,AFIDP,FIH,FIJ      !!! tmp.storage
C Gaunts:
	COMMON /GAUNT/  C                                !!! from gdata
C Rad.mesh:
	COMMON /RADMESH/NRAD,H,R,DR,WEIGHT               !!! from radmsh
C Outputs:
	COMMON /OUT0/   SCRFILE                          !!! from readini
	COMMON /WORD/   NVAL                             !!! from setup
	DATA PI/3.141592653589793D0/,C2/0.000013312838D0/
	IF(NORBS.EQ.1)RETURN
	DO 4000 IATOM=1,NATOM          !!! over atoms
	ISORT=IS(IATOM)
C  Find FIny and FIny-dot radial functions:
	DO ISPIN=1,NSPIN               !!! over spins
	DO IKAP=1,NKAP(IPAN)           !!! over energies
        CALL DFIFID(ENY(0,ISORT,IKAP,IPAN,ISPIN),AFI,AFIP,AFID,
     &  AFIDP,AFIDDS,AFIDDPS,SMT(ISORT),VSPH(0,ISORT,ISPIN),
     &  ILST(ISORT),NRAD(ISORT),H(ISORT),R(0,ISORT),DR(0,ISORT),
     &  LR(ISORT))
C  Transfere to FIH and FIJ convinient functions:
	DO L=0,ILST(ISORT)
	DO IRAD=0,NRAD(ISORT)
	FIH(IRAD,L,IKAP,ISPIN)=AAH(L,ISORT,IKAP,IPAN,ISPIN)*
     &  AFI(IRAD,L)+BBH(L,ISORT,IKAP,IPAN,ISPIN)*AFIP(IRAD,L)
	FIJ(IRAD,L,IKAP,ISPIN)=AAJ(L,ISORT,IKAP,IPAN,ISPIN)*
     &  AFI(IRAD,L)+BBJ(L,ISORT,IKAP,IPAN,ISPIN)*AFIP(IRAD,L)
        ENDDO   
        ENDDO   
        ENDDO                          !!! over energies
	ENDDO                          !!! over spins
C  Set average potential and its radial derivative
	IF(LR(ISORT).NE.0.AND.ABS(Z(ISORT)).GE.1.D-05)THEN
	DO IRAD=1,NRAD(ISORT)
	VBAR(IRAD)=-R(IRAD,ISORT)/SQRT(4.D0*PI)*
     &  (V(IRAD,1,IATOM,1)+V(IRAD,1,IATOM,NSPIN))/2.D0
        ENDDO   
	VBAR(0)=2.D0*Z(ISORT)
	CALL SDERIV1(VBAR,VDER,NRAD(ISORT),H(ISORT),R(0,ISORT),
     &  DR(0,ISORT),SMT(ISORT))
	ELSE
	DO IRAD=0,NRAD(ISORT)
	VBAR(IRAD)=0.D0
	VDER(IRAD)=0.D0
        ENDDO   
	ENDIF
	DO 3000 ISPIN=1,NSPIN          !!! over spins
	IF(ISPIN.EQ.1    )SIGN=+1.D0
	IF(ISPIN.EQ.1    )ISP1=NSPIN
	IF(ISPIN.EQ.1    )ISP =1
	IF(ISPIN.EQ.NSPIN)SIGN=-1.D0
	IF(ISPIN.EQ.NSPIN)ISP1=1
	IF(ISPIN.EQ.NSPIN)ISP =NSPIN
	DO 2000 IKAP1=1,NKAP(IPAN)     !!! over ikap1
	DO 1000 IKAP=1,NKAP(IPAN)      !!! over ikap
C READ HAMILTONIAN PARAMETERS
        IREC=IKAP1+NKAP(IPAN)*(IKAP-1)+NKAP(IPAN)**2*(IATOM-1)+
     &  NKAP(IPAN)**2*NATOM*(ISPIN-1)
        READ(13,REC=IREC)((HPARHH(L1M1,LM,IATOM),
     &  L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &  ((HPARJH(L1M1,LM,IATOM),
     &  L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &  ((HPARHJ(L1M1,LM,IATOM),
     &  L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2),
     &  ((HPARJJ(L1M1,LM,IATOM),
     &  L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2)
C NO SO-COUPLING WITH S-ELECTRONS
	SPARHH(IKAP1,IKAP,0,ISORT,ISPIN)=(0.D0,0.D0)
	SPARJH(IKAP1,IKAP,0,ISORT,ISPIN)=(0.D0,0.D0)
	SPARHJ(IKAP1,IKAP,0,ISORT,ISPIN)=(0.D0,0.D0)
	SPARJJ(IKAP1,IKAP,0,ISORT,ISPIN)=(0.D0,0.D0)
C CALCULATE RADIAL MATRIX ELEMENTS <F|1/c2*2/r*dV/dr|F> OF SO-COUPLING 
	DO L=1,ILST(ISORT)             !!! over l
	LOG1=.FALSE.
	IF(LTPAN(L,IATOM,IKAP1,IPAN))LOG1=.TRUE.
	LOG =.FALSE.
	IF(LTPAN(L,IATOM,IKAP ,IPAN))LOG =.TRUE.
	IF(L.LE.ILSB(ISORT))THEN
	SPARHH(IKAP1,IKAP,L,ISORT,ISPIN)=(0.D0,0.D0)
	SPARJH(IKAP1,IKAP,L,ISORT,ISPIN)=(0.D0,0.D0)
	SPARHJ(IKAP1,IKAP,L,ISORT,ISPIN)=(0.D0,0.D0)
	ENDIF
	SPARJJ(IKAP1,IKAP,L,ISORT,ISPIN)=(0.D0,0.D0)
C 1.1) <H|dV|H> diagonal
	IF(LOG1.AND.LOG)THEN
	WORK1(0)=(0.D0,0.D0)
	DO IRAD=1,NRAD(ISORT)          !!! over radial mesh
	WORK1(IRAD)=
     &  CONJG(FIH(IRAD,L,IKAP1,ISPIN))*FIH(IRAD,L,IKAP,ISPIN)*
     &  2.D0*(VBAR(IRAD)/R(IRAD,ISORT)-VDER(IRAD))*C2*DR(IRAD,ISORT)
        ENDDO                          !!! over radial mesh
	CALL CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	DO M=-L,L
	LM=L*(L+1)+M+1
	HPARHH(LM,LM,IATOM)=HPARHH(LM,LM,IATOM)+
     &  WORK2(NRAD(ISORT))*DBLE(M)/2.D0*SIGN
	ENDDO
C 1.2) <H|dV|H> off-diagonal
	WORK1(0)=(0.D0,0.D0)
	DO IRAD=1,NRAD(ISORT)          !!! over radial mesh
	WORK1(IRAD)=
     &  CONJG(FIH(IRAD,L,IKAP1,ISP1))*FIH(IRAD,L,IKAP,ISP)*
     &  2.D0*(VBAR(IRAD)/R(IRAD,ISORT)-VDER(IRAD))*C2*DR(IRAD,ISORT)
        ENDDO                          !!! over radial mesh
	CALL CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	SPARHH(IKAP1,IKAP,L,ISORT,ISPIN)=WORK2(NRAD(ISORT))
	ENDIF
C 2.1) <J|dV|H> diagonal
	IF(LOG)THEN
	WORK1(0)=(0.D0,0.D0)
	DO IRAD=1,NRAD(ISORT)          !!! over radial mesh
	WORK1(IRAD)=
     &  CONJG(FIJ(IRAD,L,IKAP1,ISPIN))*FIH(IRAD,L,IKAP,ISPIN)*
     &  2.D0*(VBAR(IRAD)/R(IRAD,ISORT)-VDER(IRAD))*C2*DR(IRAD,ISORT)
        ENDDO                          !!! over radial mesh
	CALL CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	DO M=-L,L
	LM=L*(L+1)+M+1
	HPARJH(LM,LM,IATOM)=HPARJH(LM,LM,IATOM)+
     &  WORK2(NRAD(ISORT))*DBLE(M)/2.D0*SIGN*GAM(L,ISORT)
	ENDDO
C 2.2) <J|dV|H> off-diagonal
	WORK1(0)=(0.D0,0.D0)
	DO IRAD=1,NRAD(ISORT)          !!! over radial mesh
	WORK1(IRAD)=
     &  CONJG(FIJ(IRAD,L,IKAP1,ISP1))*FIH(IRAD,L,IKAP,ISP)*
     &  2.D0*(VBAR(IRAD)/R(IRAD,ISORT)-VDER(IRAD))*C2*DR(IRAD,ISORT)
        ENDDO                          !!! over radial mesh
	CALL CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	SPARJH(IKAP1,IKAP,L,ISORT,ISPIN)=WORK2(NRAD(ISORT))*
     &  GAM(L,ISORT)
	ENDIF
C 3.1) <H|dV|J> diagonal
	IF(LOG1)THEN
	WORK1(0)=(0.D0,0.D0)
	DO IRAD=1,NRAD(ISORT)          !!! over radial mesh
	WORK1(IRAD)=
     &  CONJG(FIH(IRAD,L,IKAP1,ISPIN))*FIJ(IRAD,L,IKAP,ISPIN)*
     &  2.D0*(VBAR(IRAD)/R(IRAD,ISORT)-VDER(IRAD))*C2*DR(IRAD,ISORT)
        ENDDO                          !!! over radial mesh
	CALL CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	DO M=-L,L
	LM=L*(L+1)+M+1
	HPARHJ(LM,LM,IATOM)=HPARHJ(LM,LM,IATOM)+
     &  WORK2(NRAD(ISORT))*DBLE(M)/2.D0*SIGN*GAM(L,ISORT)
	ENDDO
C 3.2) <H|dV|J> off-diagonal
	WORK1(0)=(0.D0,0.D0)
	DO IRAD=1,NRAD(ISORT)          !!! over radial mesh
	WORK1(IRAD)=
     &  CONJG(FIH(IRAD,L,IKAP1,ISP1))*FIJ(IRAD,L,IKAP,ISP)*
     &  2.D0*(VBAR(IRAD)/R(IRAD,ISORT)-VDER(IRAD))*C2*DR(IRAD,ISORT)
        ENDDO                          !!! over radial mesh
	CALL CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	SPARHJ(IKAP1,IKAP,L,ISORT,ISPIN)=WORK2(NRAD(ISORT))*
     &  GAM(L,ISORT)
	ENDIF
C 4.1) <J|dV|J> diagonal
	WORK1(0)=(0.D0,0.D0)
	DO IRAD=1,NRAD(ISORT)          !!! over radial mesh
	WORK1(IRAD)=
     &  CONJG(FIJ(IRAD,L,IKAP1,ISPIN))*FIJ(IRAD,L,IKAP,ISPIN)*
     &  2.D0*(VBAR(IRAD)/R(IRAD,ISORT)-VDER(IRAD))*C2*DR(IRAD,ISORT)
        ENDDO                          !!! over radial mesh
	CALL CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	DO M=-L,L
	LM=L*(L+1)+M+1
	HPARJJ(LM,LM,IATOM)=HPARJJ(LM,LM,IATOM)+
     &  WORK2(NRAD(ISORT))*DBLE(M)/2.D0*SIGN*GAM(L,ISORT)**2
	ENDDO
C 4.2) <J|dV|J> off-diagonal
	WORK1(0)=(0.D0,0.D0)
	DO IRAD=1,NRAD(ISORT)          !!! over radial mesh
	WORK1(IRAD)=
     &  CONJG(FIJ(IRAD,L,IKAP1,ISP1))*FIJ(IRAD,L,IKAP,ISP)*
     &  2.D0*(VBAR(IRAD)/R(IRAD,ISORT)-VDER(IRAD))*C2*DR(IRAD,ISORT)
        ENDDO                          !!! over radial mesh
	CALL CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	SPARJJ(IKAP1,IKAP,L,ISORT,ISPIN)=WORK2(NRAD(ISORT))*
     &  GAM(L,ISORT)**2
        ENDDO                          !!! over l
C STORE HAMILTONIAN PARAMETERS
        IREC=IKAP1+NKAP(IPAN)*(IKAP-1)+NKAP(IPAN)**2*(IATOM-1)+
     &  NKAP(IPAN)**2*NATOM*(ISPIN-1)
        WRITE(13,REC=IREC)((HPARHH(L1M1,LM,IATOM),
     &  L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &  ((HPARJH(L1M1,LM,IATOM),
     &  L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &  ((HPARHJ(L1M1,LM,IATOM),
     &  L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2),
     &  ((HPARJJ(L1M1,LM,IATOM),
     &  L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2)
1000	CONTINUE                       !!! over ikap
2000	CONTINUE                       !!! over ikap1
3000	CONTINUE                       !!! over spins
4000	CONTINUE                       !!! over atoms
	END
