	SUBROUTINE SOVRPAR(IPAN)
***************************************************************
*  Calculation of potential parameters in the overlap matrix. *
*  Written by S.Yu.Savrasov in Max-Planck-Institute, Germany. *
***************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &   ,NKAP(NPANMAX),IATS(NPAT,NPANMAX),ISTS(NSORTMAX,NPANMAX)
	DIMENSION GAM(0:LMAXT,NSORTMAX)
	COMPLEX*16EK(NKAPMAX,NPANMAX),EKAP(NKAPMAX,NPANMAX)
     &   ,OHH(NKAPMAX,NKAPMAX,0:LMAXB,NSORTMAX,NPANMAX,NSPINMAX)
     &   ,OJH(NKAPMAX,NKAPMAX,0:LMAXB,NSORTMAX,NPANMAX,NSPINMAX)
     &   ,OHJ(NKAPMAX,NKAPMAX,0:LMAXB,NSORTMAX,NPANMAX,NSPINMAX)
     &   ,OJJ(NKAPMAX,NKAPMAX,0:LMAXT,NSORTMAX,NPANMAX,NSPINMAX)
     &   ,OPARHH(NKAPMAX,NKAPMAX,0:LMAXB,NSORTMAX,NSPINMAX)
     &   ,OPARJH(NKAPMAX,NKAPMAX,0:LMAXB,NSORTMAX,NSPINMAX)
     &   ,OPARHJ(NKAPMAX,NKAPMAX,0:LMAXB,NSORTMAX,NSPINMAX)
     &   ,OPARJJ(NKAPMAX,NKAPMAX,0:LMAXT,NSORTMAX,NSPINMAX)
     &   ,HMTHH(NKAPMAX,NKAPMAX,0:LMAXB,NSORTMAX,NSPINMAX)
     &   ,HMTJH(NKAPMAX,NKAPMAX,0:LMAXB,NSORTMAX,NSPINMAX)
     &   ,HMTHJ(NKAPMAX,NKAPMAX,0:LMAXB,NSORTMAX,NSPINMAX)
     &   ,HMTJJ(NKAPMAX,NKAPMAX,0:LMAXT,NSORTMAX,NSPINMAX)
	COMPLEX*16 OMTHH(NKAPMAX,NKAPMAX,0:LMAXB,NSORTMAX,NSPINMAX)
     &   ,OMTJH(NKAPMAX,NKAPMAX,0:LMAXB,NSORTMAX,NSPINMAX)
     &   ,OMTHJ(NKAPMAX,NKAPMAX,0:LMAXB,NSORTMAX,NSPINMAX)
     &   ,OMTJJ(NKAPMAX,NKAPMAX,0:LMAXT,NSORTMAX,NSPINMAX)
     &   ,WHH(NKAPMAX,NKAPMAX,0:LMAXT,NSORTMAX)
     &   ,WJH(NKAPMAX,NKAPMAX,0:LMAXT,NSORTMAX)
     &   ,WHJ(NKAPMAX,NKAPMAX,0:LMAXT,NSORTMAX)
     &   ,WJJ(NKAPMAX,NKAPMAX,0:LMAXT,NSORTMAX)
	LOGICAL LTPAN(0:LMAXT+1,NPAT,NKAPMAX,NPANMAX),LOG
     &   ,LSPAN(0:LMAXT+1,NSORTMAX,NKAPMAX,NPANMAX)
	COMMON /CONTROL/MAN,LMTO,NLR,NOVR                    !!! from init
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM        !!! from init
	COMMON /POTCOM/ SWZ,SMT(NSORTMAX)                    !!! from init
	COMMON /KAPPAR/ NPAN,NKAP,EK,EKAP                    !!! from init
	COMMON /PANPAR/ LTPAN,LSPAN,IATS,ISTS                !!! from init
	COMMON /LMTPAR/ GAM                                  !!! from init
	COMMON /LATPAR/ PAR                                  !!! from init
	COMMON /MTPAR / HMTHH,HMTJH,HMTHJ,HMTJJ,OMTHH,OMTJH,OMTHJ,OMTJJ
	COMMON /OVRPAR/ OPARHH,OPARJH,OPARHJ,OPARJJ          !!! from ovrpar
	COMMON /SUMPAR/ OHH,OJH,OHJ,OJJ                      !!! from ovrpar
	COMMON /INTPAR/ WHH,WJH,WHJ,WJJ                      !!! from inopar
	COMMON /SPIN/   NSPIN                                !!! from init
	COMMON /UNIT/   IUN                                  !!! from init
	COMMON /WORD/   NVAL                                 !!! from nmtdat
	DATA PI/3.141592653589793D0/
	DO 50 ISPIN=1,NSPIN                                  !!! over ispin
	DO 40 ISORT=1,NSORT                                  !!! over isort
C  FIND OVERLAP PARAMETERS IN THE INT.REGION
	CALL WRONSK1(WHH(1,1,0,ISORT),WJH(1,1,0,ISORT),
     &  WHJ(1,1,0,ISORT),WJJ(1,1,0,ISORT),SMT(ISORT),
     &  NKAP(IPAN),EKAP(1,IPAN),ILST(ISORT))
	DO 30 L=0,ILST(ISORT)                                !!! over l
	DO 20 IKAP1=1,NKAP(IPAN)                             !!! over ikap1
	DO 10 IKAP=1,NKAP(IPAN)                              !!! over ikap
C  SET POTENTIAL PARAMETERS TO ZERO
	IF(L.LE.ILSB(ISORT))THEN
	OPARHH(IKAP1,IKAP,L,ISORT,ISPIN)=(0.D0,0.D0)
	OPARJH(IKAP1,IKAP,L,ISORT,ISPIN)=(0.D0,0.D0)
	OPARHJ(IKAP1,IKAP,L,ISORT,ISPIN)=(0.D0,0.D0)
	ENDIF
	OPARJJ(IKAP1,IKAP,L,ISORT,ISPIN)=(0.D0,0.D0)
C  CALCULATE OVERLAP POTENTIAL PARAMETERS FROM WHOLE CELL
	IF(LSPAN(L,ISORT,IKAP1,IPAN).AND.LSPAN(L,ISORT,IKAP,IPAN))THEN
	IF(NOVR.EQ.0)
     &  OPARHH(IKAP1,IKAP,L,ISORT,ISPIN)=
     &  OMTHH(IKAP1,IKAP,L,ISORT,ISPIN)+WHH(IKAP1,IKAP,L,ISORT)
	IF(NOVR.EQ.1)
     &  OPARHH(IKAP1,IKAP,L,ISORT,ISPIN)=
     &  OMTHH(IKAP1,IKAP,L,ISORT,ISPIN)
	ELSE
	WHH(IKAP1,IKAP,L,ISORT)=(0.D0,0.D0)
	ENDIF
	IF(LSPAN(L,ISORT,IKAP,IPAN))THEN
	IF(NOVR.EQ.0)
     &  OPARJH(IKAP1,IKAP,L,ISORT,ISPIN)=
     &  OMTJH(IKAP1,IKAP,L,ISORT,ISPIN)+
     &  WJH(IKAP1,IKAP,L,ISORT)*GAM(L,ISORT)
	IF(NOVR.EQ.1)
     &  OPARJH(IKAP1,IKAP,L,ISORT,ISPIN)=
     &  OMTJH(IKAP1,IKAP,L,ISORT,ISPIN)
	ELSE
	WJH(IKAP1,IKAP,L,ISORT)=(0.D0,0.D0)
	ENDIF
	IF(LSPAN(L,ISORT,IKAP1,IPAN))THEN
	IF(NOVR.EQ.0)
     &  OPARHJ(IKAP1,IKAP,L,ISORT,ISPIN)=
     &  OMTHJ(IKAP1,IKAP,L,ISORT,ISPIN)+
     &  WHJ(IKAP1,IKAP,L,ISORT)*GAM(L,ISORT)
	IF(NOVR.EQ.1)
     &  OPARHJ(IKAP1,IKAP,L,ISORT,ISPIN)=
     &  OMTHJ(IKAP1,IKAP,L,ISORT,ISPIN)
	ELSE
	WHJ(IKAP1,IKAP,L,ISORT)=(0.D0,0.D0)
	ENDIF
	IF(NOVR.EQ.0)
     &  OPARJJ(IKAP1,IKAP,L,ISORT,ISPIN)=
     &  OMTJJ(IKAP1,IKAP,L,ISORT,ISPIN)+
     &  WJJ(IKAP1,IKAP,L,ISORT)*GAM(L,ISORT)*GAM(L,ISORT)
	IF(NOVR.EQ.1)
     &  OPARJJ(IKAP1,IKAP,L,ISORT,ISPIN)=
     &  OMTJJ(IKAP1,IKAP,L,ISORT,ISPIN)
	IF(L.LE.ILSB(ISORT))THEN
	OHH(IKAP1,IKAP,L,ISORT,IPAN,ISPIN)=OMTHH(IKAP1,IKAP,L,ISORT,ISPIN)
	OJH(IKAP1,IKAP,L,ISORT,IPAN,ISPIN)=OMTJH(IKAP1,IKAP,L,ISORT,ISPIN)
	OHJ(IKAP1,IKAP,L,ISORT,IPAN,ISPIN)=OMTHJ(IKAP1,IKAP,L,ISORT,ISPIN)
	ENDIF
	OJJ(IKAP1,IKAP,L,ISORT,IPAN,ISPIN)=OMTJJ(IKAP1,IKAP,L,ISORT,ISPIN)
  10    CONTINUE                                             !!! over ikap
  20    CONTINUE                                             !!! over ikap1
  30    CONTINUE                                             !!! over l
  40    CONTINUE                                             !!! over isort
  50    CONTINUE                                             !!! over ispin
	END
