        SUBROUTINE DSVFILES(IGPTB,MY,IQPNT,ICHN,TOPER)
************************************************************
*  Reads/writes/initializes induced potential in channel36 *
*  TOPER='R'ead, 'W'rite, or 'I'nitialize                  *
*  ICHN=36 for permanent/scratch storage.                  *
************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &   ,IS(NPAT),NHSORT(NSORTMAX),NRAD(NSORTMAX)
     &   ,NRAD0(NSORTMAX),ILSV0(NSORTMAX)
	COMPLEX*16 
     &    DPOT(0:NRADMAX,LMMAXV,NPAT,NSPINMAX)
     &   ,DBXC(0:NRADMAX,LMMAXV,NPAT,NSPINMAX)
	DIMENSION QPNT(3),QPNT0(3),SMT(NSORTMAX),H(NSORTMAX)
     &   ,R(0:NRADMAX,NSORTMAX),ROLD(0:NRADMAX,NSORTMAX)
	CHARACTER*60 SCNFILE(0:NENVMAX,-1:2,100),DFILE
     &   ,DROFILE(0:NENVMAX,-1:2),DSVFILE(0:NENVMAX,-1:2)
     &   ,DPSFILE(0:NENVMAX,-1:2),DPVFILE(0:NENVMAX,-1:2)
	CHARACTER TOPER*1,STATUS*3
	LOGICAL EXIST
C Controls:
	COMMON /CONTROL/LIFT,LMTO,NSPH,NINT,NPF,MODE        !!! from init
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM       !!! from init
	COMMON /SPIN/   NSPIN                               !!! from init
C Inputs:
	COMMON /QMESH/  NQPNT,QPNT                          !!! from init
	COMMON /POTCOM/ SWZ,SMT                             !!! from init
C Rad.mesh:
	COMMON /RADMESH/NRAD,H,R                            !!! from radmsh
C Potential:
	COMMON /DELPOT/ DPOT,DBXC                           !!! from delro
C Frequency:
	COMMON /FREQU/  OMGR                                !!! from init
C Outputs:
	COMMON /OUT0PH/ SCNFILE,DROFILE,DSVFILE,DPSFILE,DPVFILE!from init
        COMMON /OUT1PH/ IDSF,IDRO,IPHN,ITMP,IDSV            !!! from init
        COMMON /WORD/   NVAL                                !!! from block
	COMMON /UNIT/   IUN                                 !!! from init
        IF(IDSV.GT.0)DFILE=DSVFILE(IGPTB,MY)
        IF(IDSV.EQ.0)DFILE=SCNFILE(IGPTB,MY,ICHN)
        INQUIRE(FILE=DFILE,EXIST=EXIST)
        IF(.NOT.EXIST)STATUS='NEW'
        IF(     EXIST)STATUS='OLD'
C *** DELETE FILE
        IF(TOPER.EQ.'D')THEN
        OPEN(UNIT=ICHN,FILE=DFILE,STATUS=STATUS,
     &  FORM='UNFORMATTED',ACCESS='SEQUENTIAL')
        CLOSE(UNIT=ICHN,STATUS='DELETE')
        RETURN
        ENDIF
C *** READ DATA FROM DSVFILE OR SCNFILE
        IF(TOPER.EQ.'R')THEN
        IF(.NOT.EXIST)STOP'<DSVFILES>: FILE MUST EXIST!'
        OPEN(UNIT=ICHN,FILE=DFILE,STATUS='OLD',
     &  FORM='UNFORMATTED',ACCESS='SEQUENTIAL')
C Read control information:
        READ(ICHN)NATOM0,NSORT0,NSPIN0,(NRAD0(ISORT),ISORT=1,NSORT0),
     &  (ILSV0(ISORT),ISORT=1,NSORT0),(QPNT0(I),I=1,3),OMGR0
        READ(ICHN)((ROLD(IRAD,ISORT),IRAD=0,NRAD0(ISORT)),ISORT=1,NSORT)
        IF(NATOM0.NE.NATOM)STOP'<DSVFILES>: # OF ATOMS MISMATCH'
        IF(NSORT0.NE.NSORT)STOP'<DSVFILES>: # OF SORTS MISMATCH'
        IF(NSPIN0.NE.NSPIN)STOP'<DSVFILES>: # OF SPINS MISMATCH'
        DO ISORT=1,NSORT
        IF(NRAD0(ISORT).GT.NRADMAX)STOP'<DSVFILES>:: NRAD0>NRADMAX'
        IF(ILSV0(ISORT).GT.LMAXV  )STOP'<DSVFILES>:: ILSV0>LMAXV  '
        ENDDO
C Read change in the potential
        DO IATOM=1,NATOM                           !!! over atoms
	ISORT=IS(IATOM)
        DO ISPIN=1,NSPIN                           !!! over spins
	ITRAN=ISPIN
        READ(ICHN)((DPOT(IRAD,LM,IATOM,ISPIN),IRAD=0,NRAD0(ISORT)),
     &  LM=1,(ILSV0(ISORT)+1)**2)
        READ(ICHN)((DBXC(IRAD,LM,IATOM,ITRAN),IRAD=0,NRAD0(ISORT)),
     &  LM=1,(ILSV0(ISORT)+1)**2)
C Set zeroes for higher l's
        DO L=ILSV0(ISORT)+1,ILSV(ISORT)
        DO M=-L,L
        LM=L*(L+1)+M+1
        DO IRAD=0,NRAD0(ISORT)
        DPOT(IRAD,LM,IATOM,ISPIN)=(0.D0,0.D0)
        DBXC(IRAD,LM,IATOM,ITRAN)=(0.D0,0.D0)
        ENDDO
        ENDDO
        ENDDO
        ENDDO                                      !!! over spins
        ENDDO                                      !!! over atoms
	CLOSE(ICHN)
	ENDIF
C **** INITIALIZE CHANGE IN THE POTENTIAL
        IF(TOPER.EQ.'I')THEN
        DO IATOM=1,NATOM                           !!! over atoms
        ISORT=IS(IATOM)
        DO ISPIN=1,NSPIN                           !!! over spins
	ITRAN=ISPIN
        DO L=0,ILSV(ISORT)
        DO M=-L,L
        LM=L*(L+1)+M+1
        DO IRAD=0,NRAD(ISORT)
        DPOT(IRAD,LM,IATOM,ISPIN)=(0.D0,0.D0)
        DBXC(IRAD,LM,IATOM,ISPIN)=(0.D0,0.D0)
        ENDDO
        ENDDO
        ENDDO
        ENDDO                                      !!! over spins
        ENDDO                                      !!! over atoms
        ENDIF
C **** STORE DATA IN DSVFILE OR SCNFILE
        IF(TOPER.NE.'R')THEN
        OPEN(UNIT=ICHN,FILE=DFILE,STATUS=STATUS,
     &  FORM='UNFORMATTED',ACCESS='SEQUENTIAL')
        CLOSE(UNIT=ICHN,STATUS='DELETE')
        OPEN(UNIT=ICHN,FILE=DFILE,STATUS='NEW',
     &  FORM='UNFORMATTED',ACCESS='SEQUENTIAL')
C Store control information:
        WRITE(ICHN)NATOM,NSORT,NSPIN,(NRAD(ISORT),ISORT=1,NSORT),
     &  (ILSV(ISORT),ISORT=1,NSORT),(QPNT(I),I=1,3),OMGR
        WRITE(ICHN)((R(IRAD,ISORT),IRAD=0,NRAD(ISORT)),ISORT=1,NSORT)
C Store change in the potential
        DO IATOM=1,NATOM                           !!! over atoms
	ISORT=IS(IATOM)
        DO ISPIN=1,NSPIN                           !!! over spins
	ITRAN=ISPIN
        WRITE(ICHN)((DPOT(IRAD,LM,IATOM,ISPIN),IRAD=0,NRAD(ISORT)),
     &  LM=1,(ILSV(ISORT)+1)**2)
        WRITE(ICHN)((DBXC(IRAD,LM,IATOM,ITRAN),IRAD=0,NRAD(ISORT)),
     &  LM=1,(ILSV(ISORT)+1)**2)
        ENDDO                                      !!! over spins
        ENDDO                                      !!! over atoms
	CLOSE(ICHN)
	ENDIF
	END
