	SUBROUTINE TTRINT1(EF0,TOS,DOS,KEY)
***********************************************************
*  The calculation of the weight functions for integrati- *
*  on over IBZ by means of tetrahedron method.            *
*  Written by S.Savrasov (P.N.Lebedev Physical Institute) *
***********************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER NHSORT(NSORTMAX),IS(NPAT),NDIV(3),KTT(4)
     &   ,ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &   ,NBNDF(NPANMAX),NBNDE(NPANMAX),NBNDT(NPANMAX)
     &   ,KCUT(3,4,6),KCUW(3,4,6),IPQ(0:50,0:50,0:50)
     &   ,IGQ(0:50,0:50,0:50),IPW(0:50,0:50,0:50)
     &   ,IGW(0:50,0:50,0:50),NDIW(3),KTW(4)
	DIMENSION PNT(3,KMAX),PNW(3,KMAX)
     &   ,EARR(NDIMMAX*NSPINMAX,KMAX,NPANMAX)
     &   ,EARW(NDIMMAX*NSPINMAX,KMAX,NPANMAX)
     &   ,WEIGH(NDIMMAX*NSPINMAX,KMAX),E(4),REC(3,3)
     &   ,WEIGD(NDIMMAX*NSPINMAX,KMAX),AT(4),AD(4)
     &   ,ORTH(2:3),RBAS(3,3),GBAS(3,3),QB(3,3)
     &   ,RB(3,3),QW(3,3),RW(3,3),PKT(3,4),PKW(3,4),CRW(3,4)
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM,NHSORT    !!! from init
        COMMON /LATTICE/RBAS,GBAS,QB,RB,QW,RW                   !!! from init
	COMMON /MESH/   NPNT,PNT                                !!! from ttrmsh
	COMMON /MESW/   NPNW,PNW                                !!! from ttrmsh
        COMMON /WMESH/  KCUT,IPQ,IGQ                            !!! from bzmesh
        COMMON /WMESW/  KCUW,IPW,IGW                            !!! from bzmesh
	COMMON /ENERGY/ EARR,WEIGH,WEIGD                        !!! from lmtbnd
        COMMON /ENRWGT/ EARW                                    !!! from lmtbnd
	COMMON /KAPPAR/ NPAN                                    !!! from init
	COMMON /NBANDS/ NBNDF,NBNDE,NBNDT                       !!! from init
	COMMON /LATPAR/ PAR,ORTH,OMEGAC                         !!! from init
	COMMON /SPIN/   NSPIN                                   !!! from init
	COMMON /INTTR/  NDIV,NDIW                               !!! from init
	COMMON /UNIT/   IUN                                     !!! from init
	DATA PI/3.141592653589793D0/,EPS/1.D-10/
C *********** INITIALIZATION **************
	EF=EF0
	TOS=0.D0
	DOS=0.D0
	TOT=0.D0
	DOT=0.D0
	VOLIBZ=1.D0
	OT=1.D0/NDIV(1)/NDIV(2)/NDIV(3)/6.D0
	OW=1.D0/NDIW(1)/NDIW(2)/NDIW(3)/6.D0
C *********** TETRAHEDRON METHOD **********
        DO IPNT=1,NPNT
        DO IBNDS=1,NSPIN
        DO IBNDT=1,NBNDT(1)
        IBAND=IBNDS+NSPIN*(IBNDT-1)
        WEIGH(IBAND,IPNT)=0.D0
        WEIGD(IBAND,IPNT)=0.D0
        ENDDO
        ENDDO
        ENDDO
C  DO OVER MICROCELLS
        DO 2200 I3=0,NDIV(3)-1               !!! over cells along G3
        DO 2200 I2=0,NDIV(2)-1               !!! over cells along G2
        DO 2200 I1=0,NDIV(1)-1               !!! over cells along G1
C  THE MICROCELL IS SET UP BY I1,I2,I3
C  SET UP TETRAHEDRON INSIDE MICROCELL
        DO 2100 ITTR=1,6                     !!! over tetrahedra
        DO I=1,4
C  COORDINATES OF THE TETRAHEDRON AGE GIVEN BY KTT
        J1=I1+KCUT(1,I,ITTR)
        J2=I2+KCUT(2,I,ITTR)
        J3=I3+KCUT(3,I,ITTR)
        KTT(I)=IPQ(J1,J2,J3)
	ENDDO
C  SET UP POINTS "K" DESCRIBING TETRAHEDRON IN THE SPACE
        DO I=1,4
        J1=I1+KCUT(1,I,ITTR)
        J2=I2+KCUT(2,I,ITTR)
        J3=I3+KCUT(3,I,ITTR)
        PKT(1,I)=(J1*QB(1,1)+J2*QB(1,2)+J3*QB(1,3))*2.D0*PI/PAR
        PKT(2,I)=(J1*QB(2,1)+J2*QB(2,2)+J3*QB(2,3))*2.D0*PI/PAR
        PKT(3,I)=(J1*QB(3,1)+J2*QB(3,2)+J3*QB(3,3))*2.D0*PI/PAR
	ENDDO
C  SHIFT COORDINATE SYSTEM TO THE FIRST POINT
	DO I=2,4
	PKT(1,I)=PKT(1,I)-PKT(1,1)
	PKT(2,I)=PKT(2,I)-PKT(2,1)
	PKT(3,I)=PKT(3,I)-PKT(3,1)
	ENDDO
C  SET RECIPROCALS "REC" TO "PKT"
        CALL CROSS(REC(1,1),PKT(1,3),PKT(1,4))
        CALL CROSS(REC(1,2),PKT(1,4),PKT(1,2))
        CALL CROSS(REC(1,3),PKT(1,2),PKT(1,3))
        W=REC(1,1)*PKT(1,2)+REC(2,1)*PKT(2,2)+REC(3,1)*PKT(3,2)
	IF(ABS(W).LE.1.D-10)STOP'<TTRINT1>:: INTERNAL ERROR: W=0'
        DO I=1,3
        REC(I,1)=REC(I,1)/W
        REC(I,2)=REC(I,2)/W
        REC(I,3)=REC(I,3)/W
	ENDDO
C  DO OVER DIVISIONS OF THE MICROCELL
	DO 1200 ID3=0,NDIW(3)/NDIV(3)-1
	DO 1200 ID2=0,NDIW(2)/NDIV(2)-1
	DO 1200 ID1=0,NDIW(1)/NDIV(1)-1
C  THE SMALL MICROCELL IS SET UP BY IW1,IW2,IW3
	IW1=I1*NDIW(1)/NDIV(1)+ID1
	IW2=I2*NDIW(2)/NDIV(2)+ID2
	IW3=I3*NDIW(3)/NDIV(3)+ID3
C  SET UP SMALL TETRAHEDRON INSIDE SMALL MICROCELL
	DO 1100 ITTRD=1,6
	DO I=1,4
        JW1=IW1+KCUT(1,I,ITTRD)
        JW2=IW2+KCUT(2,I,ITTRD)
        JW3=IW3+KCUT(3,I,ITTRD)
        KTW(I)=IPW(JW1,JW2,JW3)
	ENDDO
C  SET UP POINTS K DESCRIBING SMALL TETRAHEDRON IN THE SPACE
        DO I=1,4
        JW1=IW1+KCUT(1,I,ITTRD)
        JW2=IW2+KCUT(2,I,ITTRD)
        JW3=IW3+KCUT(3,I,ITTRD)
        PKW(1,I)=(JW1*QW(1,1)+JW2*QW(1,2)+JW3*QW(1,3))*2.D0*PI/PAR
        PKW(2,I)=(JW1*QW(2,1)+JW2*QW(2,2)+JW3*QW(2,3))*2.D0*PI/PAR
        PKW(3,I)=(JW1*QW(3,1)+JW2*QW(3,2)+JW3*QW(3,3))*2.D0*PI/PAR
	ENDDO
C  SHIFT COORDINATE SYSTEM TO THE FIRST POINT
	DO I=1,4
	PKW(1,I)=PKW(1,I)-PKT(1,1)
	PKW(2,I)=PKW(2,I)-PKT(2,1)
	PKW(3,I)=PKW(3,I)-PKT(3,1)
	ENDDO
C  CHECK WHETHER A SMALL TETRAHEDRON "PKW" IS INSIDE  TETRAHEDRON "PKT"
	DO I=1,4
        X1=PKW(1,I)*REC(1,1)+PKW(2,I)*REC(2,1)+PKW(3,I)*REC(3,1)
        X2=PKW(1,I)*REC(1,2)+PKW(2,I)*REC(2,2)+PKW(3,I)*REC(3,2)
        X3=PKW(1,I)*REC(1,3)+PKW(2,I)*REC(2,3)+PKW(3,I)*REC(3,3)
	IF(.NOT.((X1.GE.-EPS.AND.X1.LE.1.D0+EPS).AND.
     &	         (X2.GE.-EPS.AND.X2.LE.1.D0+EPS).AND.
     &	         (X3.GE.-EPS.AND.X3.LE.1.D0+EPS).AND.
     &           (X1+X2+X3.LE.1.D0+EPS)))GOTO1100
	CRW(1,I)=X1
	CRW(2,I)=X2
	CRW(3,I)=X3
	ENDDO
C  CALCULATE CONTRIBUTION TO THE POINTS GIVEN BY "KTT=PKT"
        DO 1000 IBNDS=1,NSPIN                     !!! over spin subbands
        DO 1000 IBNDT=1,NBNDT(1)                  !!! over valence bands
        IBAND=IBNDS+NSPIN*(IBNDT-1)
	DO I=1,4
	IPNT=KTW(I)
	E(I)=EARW(IBAND,IPNT,1)
	ENDDO
	CALL MCTTRINT0(E,EF,OW,AT,AD,TS,DS,'B','W')
	TOS=TOS+TS
	DOS=DOS+DS
	DO IT=1,4
	IPNT=KTT(IT)
	DO I=1,4
	IF(IT.EQ.1)WF=1.D0-CRW(1,I)-CRW(2,I)-CRW(3,I)
	IF(IT.NE.1)WF=CRW(IT-1,I)
	WEIGH(IBAND,IPNT)=WEIGH(IBAND,IPNT)+AT(I)*WF
	WEIGD(IBAND,IPNT)=WEIGD(IBAND,IPNT)+AD(I)*WF
	ENDDO
	ENDDO
1000    CONTINUE                                  !!! over valence bands
1100	CONTINUE                                  !!! over small tetrahedra
1200	CONTINUE                                  !!! over small microcells
2100	CONTINUE                                  !!! over tetrahedra
2200	CONTINUE                                  !!! over microcells
C  NORMALIZATION
	DO IPNT=1,NPNT
        DO IBNDS=1,NSPIN
        DO IBNDT=1,NBNDT(1)
        IBAND=IBNDS+NSPIN*(IBNDT-1)
	WEIGH(IBAND,IPNT)=WEIGH(IBAND,IPNT)/VOLIBZ*2.D0/DBLE(NSPIN)
	WEIGD(IBAND,IPNT)=WEIGD(IBAND,IPNT)/VOLIBZ*2.D0/DBLE(NSPIN)
	TOT=TOT+WEIGH(IBAND,IPNT)
	DOT=DOT+WEIGD(IBAND,IPNT)
	ENDDO
	ENDDO
	ENDDO
C ************ END OF INTEGRATION ***********
	TOS=TOS/VOLIBZ*2.D0/DBLE(NSPIN)
	DOS=DOS/VOLIBZ*2.D0/DBLE(NSPIN)
	IF(KEY.EQ.0)WRITE(IUN,1010)EF,TOS,DOS
	IF(ABS(TOS-TOT).GE.1.D-07)WRITE(IUN,1020)TOS,TOT
	IF(ABS(DOS-DOT).GE.1.D-07)WRITE(IUN,1030)DOS,DOT
1010    FORMAT(' EF,TOS,DOS==',3(1X,G14.7))
1020    FORMAT(' TOS-WEIGHTS MISMATCH :',G14.7,2X,G14.7)
1030    FORMAT(' DOS-WEIGHTS MISMATCH :',G14.7,2X,G14.7)
	RETURN
	END
